% % answer key to homework 2, problem 3
% % written by Anton Cheremukhin on January 31 2008
close all;
clear all;
clc;
global beta;
betai=0.01:0.01:1.5;       m=size(betai,2);
options = optimset('LargeScale','off');%,'MaxIter',100);
ub=[1.999,0.999,0,0];
lb=[0.001,-0.999,0,0];
x_=[1,0,0,0 ];

for i=1:m
    beta=betai(i);
    x(i,:) = fmincon(@myfun2,x_,[],[],[],[],lb,ub,@mycon2,options);
    x0(i,:) = fmincon(@myfun2,x_,[],[],[],[],lb,ub,[],options);
    W(i,1)=-myfun2(x(i,:));
    W0(i,1)=-myfun2(x0(i,:));
end

figure;
plot(betai',x(:,1),'-',betai',x(:,2),':',...
    'LineWidth',3);
legend('\tau_{1}','\tau_{2}')
title('Transfers as a function \beta (Second Best)')
xlabel('\beta')
ylabel('\tau')

figure;
plot(betai',x0(:,1),'-',betai',x0(:,2),':',...
    'LineWidth',3);
legend('\tau_{1}','\tau_{2}')
title('Transfers as a function \beta (First best)')
xlabel('\beta')
ylabel('\tau')

figure;
plot(betai',W(:,1),'-',betai',W0(:,1),':',betai',betai'+1-0.5*log(2),'r-.',...
    'LineWidth',3);
legend('Second best','First best','With Financial Markets',4)
title('Welfare')
xlabel('\beta')
ylabel('W')
