% answer key to homework 1, problem 4
% written by Anton Cheremukhin on January 27 2008
close all;
clear all;
clc;
c=0.01:0.01:10;    n=size(c,2);
e=0.025:0.025:4;     m=size(e,2);
U1=0.125*log(c);
U2=sqrt(c);
f=[-0.5*U1,-0.5*U2];
A=[c,c;-U1,U1;U2,-U2];
Aeq=[ones(1,n),zeros(1,n);zeros(1,n),ones(1,n)];
beq=[1;1];
ub=ones(1,2*n);
lb=zeros(1,2*n);
k1=zeros(m,1);
k2=zeros(m,1);
c1=zeros(m,3);
c2=zeros(m,3);
pi1=zeros(m,2);
pi2=zeros(m,2);
for i=1:m
    b=[2*e(i);0;0];
    pi=linprog(f,A,b,Aeq,beq,lb,ub);
    W(i)=-f*pi;
    pi0=linprog(f,A(1,:),b(1,:),Aeq,beq,lb,ub);
    W0(i)=-f*pi0;
    WA(i)=0.5*(0.125*log(e(i))+sqrt(e(i)));
    pi1_=pi(1:n);
    pi2_=pi(n+1:2*n);
    j1=n+2;
    j2=n+2;
    pij1=0;
    pij2=0;
    for j=n:-1:1
        if pi1_(j)>0.001
           if j1-j>1
               k1(i)=k1(i)+1;       %update the number of positive probabilities
               c1(i,k1(i))=c(j);    %save the consumption
               pi1(i,k1(i))=pi1_(j);    %save the probability
               pij1=pi1_(j);            %remember it
           else
               pij1=pij1+pi1_(j);
               c1(i,k1(i))=(c1(i,k1(i))*(pij1-pi1_(j))+c(j)*pi1_(j))/pij1;  %update consumption
               pi1(i,k1(i))=pi1(i,k1(i))+pi1_(j);   %update the probability
           end
           j1=j;
        end
        if pi2_(j)>0.001
           if j2-j>1
               k2(i)=k2(i)+1;       %update the number of positive probabilities
               c2(i,k2(i))=c(j);    %save the consumption
               pi2(i,k2(i))=pi2_(j);    %save the probability
               pij2=pi2_(j);            %remember it
           else
               pij2=pij2+pi2_(j);
               c2(i,k2(i))=(c2(i,k2(i))*(pij2-pi2_(j))+c(j)*pi2_(j))/pij2; %update consumption
               pi2(i,k2(i))=pi2(i,k2(i))+pi2_(j);   %update the probability
           end
           j2=j;
        end
    end
end
for j=1:m
    for i=1:3
        if c1(j,i)==0
           c1(j,i)=c1(j,i-1);
        end
        if c2(j,i)==0
           c2(j,i)=c2(j,i-1);
        end
    end
end
figure
plot(e(1:m),c1(1:m,1)','r',e(1:m),c2(1:m,1),'b',e(1:m),c2(1:m,2),'g',... %,e(1:m),c2(1:m,3),'b',...
    'LineWidth',2)
legend('type I','type II','type II',2)

figure
plot(e(1:m),pi1(1:m,1)','r',e(1:m),pi2(1:m,1),'b',e(1:m),pi2(1:m,2),'g',...%,e(1:m),pi2(1:m,3),'b',...
    'LineWidth',2)
legend('type I','type II','type II',2)

figure
plot(e,W,'r',e,W0,'b',e,WA,'g',...%,e(1:m),pi2(1:m,3),'b',...
    'LineWidth',2)
legend('Welfare','First Best','Autarky',2)

